package com.ydl.ydl_pay.http.utils

import com.ydl.ydl_pay.http.response.BaseResponse
import io.reactivex.Observable
import io.reactivex.ObservableTransformer
import java.net.ConnectException

/**
 * author : Zhangwenchao
 * e-mail : zhangwch@yidianling.com
 */
object RxHttpUtils {


    /**
     * 根据返回数据，得到真正需要的数据
     * 若状态码不为0，抛出接口异常
     */
    @JvmStatic
    fun <T> resultData(): ObservableTransformer<BaseResponse<T>, T> {
        return ObservableTransformer {
            it.flatMap {
                if (it.code == 0) Observable.just(it.data)
                else Observable.error(Throwable(it.msg))
            }
        }
    }
}
